#!/usr/bin/python2.7
# -*- coding: utf-8 -*-
#
# Copyright (C) 2013-2015 Univention GmbH
#
# http://www.univention.de/
#
# All rights reserved.
#
# The source code of this program is made available
# under the terms of the GNU Affero General Public License version 3
# (GNU AGPL V3) as published by the Free Software Foundation.
#
# Binary versions of this program provided by Univention to you as
# well as other copyrighted, protected or trademarked materials like
# Logos, graphics, fonts, specific documentations and configurations,
# cryptographic keys etc. are subject to a license agreement between
# you and Univention and not subject to the GNU AGPL V3.
#
# In the case you use this program under the terms of the GNU AGPL V3,
# the program is provided in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public
# License with the Debian GNU/Linux or Univention distribution in file
# /usr/share/common-licenses/AGPL-3; if not, see
# <http://www.gnu.org/licenses/>.

from univention.config_registry import ConfigRegistry
import csv

csvfilename = '/usr/share/univention-ox/attrlist.csv'
pwfilename = '/etc/ldap.secret'

ucr = ConfigRegistry()
ucr.load()
ldapbase = ucr['ldap/base']

from optparse import OptionParser

_parser = OptionParser()
_parser.add_option('--binddn', action='store', dest='binddn', help = 'ldap bind dn for UDM CLI operation' )
_parser.add_option('--bindpwd', action='store', dest='bindpwd', help = 'ldap bind password for bind dn' )
(options, params) = _parser.parse_args()

if options.binddn:
	binddn = options.binddn
else:
	binddn = 'cn=admin,%s' % ldapbase

if options.bindpwd:
	bindpwd = options.bindpwd
else:
	bindpwd = open(pwfilename).read().strip()

attrmap = csv.DictReader(open(csvfilename))
for row in attrmap:
	print 'univention-directory-manager settings/extended_attribute create --binddn "%s" --bindpwd "%s" \\' % (binddn, bindpwd)
	print '--position "cn=open-xchange,cn=custom attributes,cn=univention,%s" --set module="%s" \\' % (ldapbase, row['module'])
	print '--set ldapMapping=\'%s\' \\' % row['ldapMapping']
	print '--set objectClass=\'%s\' \\' % row['objectClass']
	print '--set name=\'%s\' \\' % row['name']
	print '--set shortDescription=\'%s\' \\' % row['shortDescription']
	print '--set longDescription=\'%s\' \\' % row['longDescription']
	print '--set translationShortDescription=\'"de_DE" "%s"\' \\' % row['translationShortDescription']
	print '--set translationLongDescription=\'"de_DE" "%s"\' \\' % row['translationLongDescription']
	print '--set tabName=\'%s\' \\' % row['tabName']
	print '--set translationTabName=\'"de_DE" "%s"\' \\' % row['translationTabName']
	print '--set overwriteTab=\'%s\' \\' % row['overwriteTab']
	print '--set valueRequired=\'%s\' \\' % row['valueRequired']
	print '--set CLIName=\'%s\' \\' % row['CLIName']
	print '--set syntax=\'%s\' \\' % row['syntax']
	print '--set tabAdvanced=\'%s\' \\' % row['tabAdvanced']
	print '--set default=\'%s\' \\' % row['default']
	print '--set mayChange=\'%s\' \\' % row['mayChange']
	print '--set multivalue=\'%s\' \\' % row['multivalue']
	print '--set deleteObjectClass=\'%s\' \\' % row['deleteObjectClass']
	print '--set tabPosition=\'%s\' \\' % row['tabPosition']
	print '--set overwritePosition=\'%s\' \\' % row['overwritePosition']
	print '--set doNotSearch=\'%s\' \\' % row['doNotSearch']
	print '--set hook=\'%s\' \\' % row['hook']
	if row.get("groupName"):
		print '--set groupName=\'%s\' \\' % row['groupName']
	if row.get("translationGroupName"):
		print '--set translationGroupName=\'"de_DE" "%s"\' \\' % row['translationGroupName']
	if row.get("groupPosition"):
		print '--set groupPosition=\'%s\' \\' % row['groupPosition']
	#print '--set =\'%s\' \\' % row['']
	print ''
